Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.basex.query.expr
Class Preds

    java.lang.Object
      org.basex.query.ExprInfo
          org.basex.query.expr.Expr
              org.basex.query.expr.Preds

Direct Known Subclasses:
  Pred, Step

    public abstract class Preds

extends Expr

Abstract predicate expression, implemented by `Pred` and `Step`.

Author:
  Workgroup DBIS, University of Konstanz 2005-09, ISC License, Christian Gruen

Field Summary
`Expr[]` | `pred` Predicates.

Constructor Summary
`Preds(Expr[] p)` Constructor.

Method Summary
`java.lang.String` | `color()` Returns a string description of the expression.
`Expr` | `comp(QueryContext ctx)` Optimizes and compiles the expression.
`void` | `plan(Serializer ser)` Recursively sends the abstract syntax of this expression to the specified serializer.
`boolean` | `removable(Var v, QueryContext ctx)` Checks if the specified variable is removable.
`Expr` | `remove(Var v)` Removes the specified variable in a sub expression.
`java.lang.String` | `toString()`
`boolean` | `uses(Expr.Use use, QueryContext ctx)` Indicates if an expression uses the specified type.

Methods inherited from class org.basex.query.expr.Expr
`addText, atomic, checkCtx, checkDbl, checkItr, duplicates, e, ebv, i, indexAccessible, indexEquivalent, iter, returned, sameAs, size, test`

Methods inherited from class org.basex.query.ExprInfo
`info, name`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### pred

    public Expr[] pred

  Predicates.

Constructor Detail

### Preds

    public Preds(Expr[] p)

  Constructor.

  Parameters:
    `p` - predicates

Method Detail

### comp

    public Expr comp(QueryContext ctx)
              throws QueryException

  Description copied from class: `Expr`
  Optimizes and compiles the expression.

  Specified by:
    `comp` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    optimized Expression
  Throws:
    `QueryException` - evaluation exception

### uses

    public boolean uses(Expr.Use use,
                        QueryContext ctx)

  Description copied from class: `Expr`
  Indicates if an expression uses the specified type. Called by the compiler to perform certain optimizations. `true` is returned by default and thus assumed as "worst-case".

  Overrides:
    `uses` in class `Expr`
  Parameters:
    `use` - use type to be checked
    `ctx` - query context
  Returns:
    result of check

### removable

    public boolean removable(Var v,
                             QueryContext ctx)

  Description copied from class: `Expr`
  Checks if the specified variable is removable.

  Overrides:
    `removable` in class `Expr`
  Parameters:
    `v` - variable to be removed
    `ctx` - query context
  Returns:
    result of check

### remove

    public Expr remove(Var v)

  Description copied from class: `Expr`
  Removes the specified variable in a sub expression.

  Overrides:
    `remove` in class `Expr`
  Parameters:
    `v` - variable to be removed
  Returns:
    expression with removed variable

### color

    public final java.lang.String color()

  Description copied from class: `ExprInfo`
  Returns a string description of the expression. Contrary to the `ExprInfo.toString()` method, the current expressions aren't included in the output.

  Overrides:
    `color` in class `ExprInfo`
  Returns:
    result of check

### plan

    public void plan(Serializer ser)
              throws java.io.IOException

  Description copied from class: `ExprInfo`
  Recursively sends the abstract syntax of this expression to the specified serializer.

  Specified by:
    `plan` in class `ExprInfo`
  Parameters:
    `ser` - serializer
  Throws:
    `java.io.IOException` - exception

### toString

    public java.lang.String toString()

  Specified by:
    `toString` in class `ExprInfo`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD